package com.jxdinfo.hussar.core.bouncycastle.math.ec;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jxdinfo.hussar.core.bouncycastle.asn1.x9.X9IntegerConverter;
import com.jxdinfo.hussar.core.bouncycastle.math.ec.ECCurve;
import com.jxdinfo.hussar.core.bouncycastle.math.ec.ECFieldElement;
import com.jxdinfo.hussar.core.bouncycastle.math.ec.Prn;
import com.jxdinfo.hussar.core.bouncycastle.math.ec.aUX;
import com.jxdinfo.hussar.core.util.ResKit;
import java.math.BigInteger;

public abstract class ECPoint {
  ECFieldElement G;
  
  protected aUX preCompInfo = (aUX)(this.multiplier = null);
  
  ECCurve C;
  
  protected Prn multiplier;
  
  protected boolean withCompression;
  
  ECFieldElement e;
  
  private static X9IntegerConverter enum = new X9IntegerConverter();
  
  public ECFieldElement getY() {
    return this.e;
  }
  
  public int hashCode() {
    if (isInfinity())
      return 0; 
    while (true)
      return this.G.hashCode() ^ this.e.hashCode(); 
  }
  
  public ECCurve getCurve() {
    return this.C;
  }
  
  public abstract com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint twice();
  
  protected ECPoint(ECCurve eCCurve, ECFieldElement eCFieldElement1, ECFieldElement eCFieldElement2) {
    this.C = eCCurve;
    this.G = eCFieldElement1;
    this.e = eCFieldElement2;
  }
  
  public ECFieldElement getX() {
    return this.G;
  }
  
  public boolean isInfinity() {
    if (this.G == null && this.e == null)
      return true; 
    while (true)
      return false; 
  }
  
  public boolean equals(Object a) {
    // Byte code:
    //   0: aload_1
    //   1: aload_0
    //   2: if_acmpne -> 8
    //   5: iconst_1
    //   6: ireturn
    //   7: pop
    //   8: aload_1
    //   9: instanceof com/jxdinfo/hussar/core/bouncycastle/math/ec/ECPoint
    //   12: ifne -> 18
    //   15: iconst_0
    //   16: ireturn
    //   17: iconst_0
    //   18: aload_1
    //   19: checkcast com/jxdinfo/hussar/core/bouncycastle/math/ec/ECPoint
    //   22: astore_1
    //   23: aload_0
    //   24: invokevirtual isInfinity : ()Z
    //   27: ifeq -> 35
    //   30: aload_1
    //   31: invokevirtual isInfinity : ()Z
    //   34: ireturn
    //   35: aload_0
    //   36: getfield G : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   39: aload_1
    //   40: getfield G : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   43: invokevirtual equals : (Ljava/lang/Object;)Z
    //   46: ifeq -> 65
    //   49: aload_0
    //   50: getfield e : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   53: aload_1
    //   54: getfield e : Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECFieldElement;
    //   57: invokevirtual equals : (Ljava/lang/Object;)Z
    //   60: ifeq -> 65
    //   63: iconst_1
    //   64: ireturn
    //   65: iconst_0
    //   66: ireturn
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	67	0	a	Lcom/jxdinfo/hussar/core/bouncycastle/math/ec/ECPoint;
    //   0	67	1	a	Ljava/lang/Object;
  }
  
  public abstract com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint negate();
  
  void package(aUX aUX1) {
    this.preCompInfo = aUX1;
  }
  
  public abstract byte[] getEncoded();
  
  public abstract com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint add(com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint paramECPoint);
  
  public com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint multiply(BigInteger bigInteger) {
    if (bigInteger.signum() < 0)
      throw new IllegalArgumentException(ResKit.else("\021%&kcs\t\031\n\033\034\021,&=.<f7=#+:)l&1|'$798-/4")); 
    if (isInfinity())
      return this; 
    while (true) {
      if (bigInteger.signum() == 0)
        return this.C.getInfinity(); 
      while (true) {
        enum();
        return this.multiplier.char(this, bigInteger, this.preCompInfo);
      } 
    } 
    while (true) {
      enum();
      return this.multiplier.char(this, bigInteger, this.preCompInfo);
    } 
  }
  
  public abstract com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint subtract(com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint paramECPoint);
  
  public boolean isCompressed() {
    return this.withCompression;
  }
  
  synchronized void enum() {
    if (this.multiplier == null) {
      this;
      super();
    } 
  }
}
